//----------------------------------------------------------------------------------
// aviutl GPUoCetB^
// Copyright (c) 2008  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <xmmintrin.h>
#include <strsafe.h>
#include <new>

#include <d3d9.h>
#include <d3dx9.h>
#include <dxerr.h>

#include "filter.h"
#include "prof.h"
#include "gpufilter.h"

//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
GpuFilter *g_pGpuFilter = NULL;
bool g_chg_param = true;
bool g_need_realloc = true;

//ptH[}Xp
#ifdef PROFILE_GPU
HWND g_debugWindow = 0;
double g_QPFreq = 1.0;
PData g_prof;
bool g_flush = true;
#endif

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
// UNICODErh邽ߏςɂȂĂ܂iDXTrace()Ȃ߁j
LPSTR track_name[TRACK_N] =
{ "", "臒l",  "͈", "pX", "[h" };
int track_default[TRACK_N] = { 128, 24, 64, 1, 0 };
int track_s[TRACK_N] = { 0, 0, 0, 1, 0 };
int track_e[TRACK_N] = { 256, 256, 256, 5, 2 };

#ifdef PROFILE_GPU
LPSTR check_name[] = { "AChԂɂȂ܂ő҂", "U16ɋ" };
int check_default[] = { 0, 0 };
#endif

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION|FILTER_FLAG_NO_INIT_DATA, 0, 0,
#ifdef PROFILE_GPU
	(TCHAR*)"GPU Bilateral(Prof)",
#else
	(TCHAR*)"GPU Bilateral",
#endif
	TRACK_N, (TCHAR**)track_name, track_default, track_s, track_e,
#ifdef PROFILE_GPU
	ARRAYSIZE(check_name), (TCHAR**)check_name, check_default,
#else
	0, (TCHAR**)NULL, NULL,
#endif
	func_proc,
	func_init,
	func_exit,
	func_update,
	func_WndProc,
	NULL, NULL, NULL, 0,
	(TCHAR*)"gpu_blf by N099, ver0.9",
	NULL,  NULL,
};

//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
	//GpuFilter
	g_pGpuFilter = new(std::nothrow) GpuFilter;
	if(NULL == g_pGpuFilter){
		return FALSE;
	}

	//FfoCX̃eXgs
	if(!g_pGpuFilter->Init(fp)){
		SAFE_DELETE(g_pGpuFilter);
		return FALSE;
	}

#ifdef PROFILE_GPU
	//get PerformanceCounter frequency
	LARGE_INTEGER ticFreq = {0,0};
	QueryPerformanceFrequency(&ticFreq);
	if(ticFreq.QuadPart>0){
		_mm_empty();
		g_QPFreq = (double)ticFreq.QuadPart;
	}

	//create debug window
	g_debugWindow = CreateWindow(TEXT("EDIT"), TEXT("Debug GPU_BLT"),
		WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | ES_MULTILINE | ES_READONLY,
		CW_USEDEFAULT, 0,
		180, 282,
		fp->hwnd, NULL, fp->dll_hinst, NULL);
	if(g_debugWindow){
		SendMessage(g_debugWindow, WM_SETFONT, 
			(WPARAM)GetStockObject(OEM_FIXED_FONT), (LPARAM)TRUE);
	}
#endif

	return TRUE;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit(FILTER *fp)
{
#ifdef PROFILE_GPU
	if(g_debugWindow) DestroyWindow(g_debugWindow);
#endif

	SAFE_DELETE(g_pGpuFilter);

	return TRUE;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	static int n;

	if(!g_pGpuFilter) return FALSE;

	if(TRUE != fp->exfunc->set_ycp_filtering_cache_size(
		fp, fpip->max_w, fpip->max_h, 2, NULL))
	{
		return FALSE;
	}

#ifdef PROFILE_GPU
	//GPȔI҂
	ZeroMemory(&g_prof, sizeof(g_prof));
	g_flush = fp->check[C_FLUSH] ? true : false;
	getCount(TEXT("Init   "));
#endif

	//t[̉摜擾
	PIXEL_YC *pyc = fp->exfunc->get_ycp_filtering_cache_ex(
			fp, fpip->editp, fpip->frame, &fpip->w, &fpip->h);
	if(pyc == NULL) return FALSE;
	getCount(TEXT("CacheCur"));

	//TCYύX̃`FbN
	if(fpip->w != g_pGpuFilter->GetWidth() || fpip->h != g_pGpuFilter->GetHeight()){
		g_need_realloc = true;
	}

	//foCX̏Ԃ`FbN
	if(!g_pGpuFilter->TestDeviceState(&g_need_realloc)) return FALSE;

	//p[^ύXꂽꍇ
	if(g_need_realloc){
		g_pGpuFilter->ReleaseResources();
#ifdef PROFILE_GPU
		g_pGpuFilter->AllocResources(fpip->w, fpip->h, fpip->max_w, fp->check[C_U16]);
#else
		g_pGpuFilter->AllocResources(fpip->w, fpip->h, fpip->max_w);
#endif
		g_pGpuFilter->SetParams(fp->track, fp->check);
		getCount(TEXT("AllocRes"));

		g_need_realloc = false;
		g_chg_param = false;
	}else if(g_chg_param){
		g_pGpuFilter->SetParams(fp->track, fp->check);
		getCount(TEXT("SetParam"));
		g_chg_param = false;
	}

	//f[^GPUɓ]
	if(!g_pGpuFilter->PutImage(pyc, fp->exfunc->exec_multi_thread_func)){
		return FALSE;
	}
	getCount(TEXT("PutUnlck"));

	//GPUŏ
	if(fp->track[T_PMODE] < 2){
		//
		if(!g_pGpuFilter->ProcImage(fp->track[T_PMODE])) return FALSE;
		getCount(TEXT("Proc    "));
	}else{
		//񓯊
		if(!g_pGpuFilter->ProcImageAsync()) return FALSE;
		getCount(TEXT("ProcAsyn"));
	}

	n = fpip->frame - n;
	if(fp->track[T_PMODE]){
		if(n){
			fp->exfunc->get_ycp_filtering_cache_ex(
				fp, fpip->editp, fpip->frame + n, NULL, NULL);
		}
		n = fpip->frame;
		getCount(TEXT("CacheNxt"));
	}

	//o̓f[^o
	if(!g_pGpuFilter->GetImage(fpip->ycp_edit, fp->exfunc->exec_multi_thread_func)){
		return FALSE;
	}
	getCount(TEXT("GetUnlck"));

	printCount();

	return TRUE;
}

//---------------------------------------------------------------------
// ݒύXɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_update(FILTER *fp, int status)
{
	g_chg_param = true;
#ifdef PROFILE_GPU
	if(g_pGpuFilter){
		if(g_pGpuFilter->GetPixelFormat() != 
			g_pGpuFilter->PixelFormatFromIndex(fp->check[C_U16]))
		{
			g_need_realloc = true;
		}
	}
#endif

	return TRUE;
}

//---------------------------------------------------------------------
// ݒEBhEɃEBhEbZ[WɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_WndProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam,void *editp,FILTER *fp)
{
	switch(message){
	case WM_FILTER_CHANGE_ACTIVE: //tB^̗L/ύXꂽɑ܂
		if(g_pGpuFilter && !fp->exfunc->is_filter_active(fp)){
			g_pGpuFilter->ReleaseResources();
			g_need_realloc = true;
		}
		break;
	default:
		break;
	}

	return FALSE;
}

//ptH[}Xp
#ifdef PROFILE_GPU
void getCount(const TCHAR *tag)
{
	if(g_flush){
		g_pGpuFilter->WaitForIdle();
	}
	QueryPerformanceCounter(&g_prof.pc[g_prof.i].c);
	lstrcpy(g_prof.pc[g_prof.i].s, tag);
	g_prof.i++;
}

void printCount()
{
	TCHAR buf[512];
	TCHAR buf0[64];
	const TCHAR *fmt = TEXT("?");
	double ticks,rQPF;
	int h,w;

	_mm_empty();

	if(NULL == g_debugWindow) return;
	if(g_pGpuFilter){
		h = g_pGpuFilter->GetHeight();
		w = g_pGpuFilter->GetWidth();
		fmt = g_pGpuFilter->GetPixelFormatStr();
	}else{
		h = w = 0;
	}

	rQPF = 1.0 / g_QPFreq;
#if 0
	StringCchPrintf(buf, 512,
		TEXT("Size :%dx%d(%s)\r\nQPF  :%.5E\r\n"), w,h, fmt, g_QPFreq);
#else
	StringCchPrintf(buf, 512, TEXT("Size :%dx%d(%s)\r\n"), w,h, fmt);
#endif
	for(int i=1; i<g_prof.i; ++i){
		ticks = (double)(g_prof.pc[i].c.QuadPart - g_prof.pc[i-1].c.QuadPart) * rQPF;
		StringCchPrintf(buf0, 64, TEXT("%s:%.5E\r\n"), g_prof.pc[i].s, ticks);
		lstrcat(buf, buf0);
	}

	//All
	ticks = (double)(g_prof.pc[g_prof.i - 1].c.QuadPart - g_prof.pc[0].c.QuadPart) * rQPF;
	StringCchPrintf(buf0, 64, TEXT("%s:%.5E\r\n"), TEXT("All     "), ticks);
	lstrcat(buf, buf0);

	SendMessage(g_debugWindow, WM_SETTEXT, 0, (LPARAM)buf);  
}
#endif
