//----------------------------------------------------------------------------------
// aviutl  GPUoCetB^
// Copyright (c) 2008  N099
//----------------------------------------------------------------------------------
#pragma once

//p[^`Ȃ
#define TRACK_N 5
enum { T_GAIN, T_SIM, T_DOM, T_NPAS, T_PMODE };
enum { C_FLUSH, C_U16 };

#define PARAM_N 3
enum { PARAM_GAIN, PARAM_SIM, PARAM_DOM };

//MT
typedef BOOL (__cdecl * EXEC_MT)(MULTI_THREAD_FUNC, void*, void*);
class ThrProc;

//GPUtB^NX
class GpuFilter
{
public:
	enum PIXEL_FORMAT { S16 = 0, U16, Unknown };

private:
	IDirect3D9 *m_pD3D; //IDirect3D9IuWFNg
	IDirect3DDevice9 *m_pd3dDevice; //D3DfoCX

	IDirect3DTexture9 *m_pSrcTex; //f[^peNX`
	IDirect3DTexture9 *m_pRtTex[2]; //RTeNX`
	IDirect3DSurface9 *m_pSrfSys; //Rs[ɗpT[tFX
	
	IDirect3DVertexBuffer9 *m_pVert; //`p_
	IDirect3DVertexDeclaration9 *m_pVertDec; //`p_錾

	ID3DXEffect *m_pEffect; //GtFNg
	IDirect3DQuery9* m_pQuery;

	//p[^
	D3DXHANDLE m_hParam[PARAM_N];
	D3DXHANDLE m_hTec[2];
	D3DXHANDLE m_hTex;

	int m_width;
	int m_height;
	int m_wMax;
	int m_nPass;

	PIXEL_FORMAT m_pixFormat; //sNZtH[}bg
	bool m_pixFormatAvailable[Unknown];

	ThrProc *m_tproc;

public:
	GpuFilter();
	~GpuFilter();

	bool Init(FILTER *fp);
	bool Release();
	bool AllocResources(int w, int h, int w_max, int fmt = S16);
	bool ReleaseResources();
	bool SetParams(int *track, int *check);
	bool TestDeviceState(bool *need_realloc);
	bool PutImage(const PIXEL_YC *data, EXEC_MT func_mt);
	bool ProcImage(int empty = 1);
	bool ProcImageAsync();
	bool GetImage(PIXEL_YC *data, EXEC_MT func_mt);

	int GetWidth() const { return m_width; }
	int GetHeight() const { return m_height; }
	PIXEL_FORMAT GetPixelFormat(void) const { return m_pixFormat; }
	const TCHAR *GetPixelFormatStr(void) const;
	PIXEL_FORMAT PixelFormatFromIndex(int i) const
	{ return (PIXEL_FORMAT)((i<0) ? 0 : ((i>Unknown) ? Unknown : i)); }
#ifdef PROFILE_GPU
	void WaitForIdle();
#endif
private:
	HRESULT CheckDeviceCap();
	HRESULT CreateEffect(const TCHAR *res, HMODULE hm);
	HRESULT CreateVert();
	HRESULT CreateTexture(IDirect3DTexture9 **ppTex, DWORD usage, D3DPOOL pool);
	HRESULT CreateSurface(IDirect3DSurface9 **ppSrf, DWORD usage, D3DPOOL pool);
	HRESULT CreateSysMemResources();
	HRESULT CreateDefaultResources();
	HRESULT SetEffectResources();
	HRESULT Reset();
	HRESULT PutPixelData(IDirect3DSurface9 *sys, const PIXEL_YC *src, EXEC_MT func_mt);
	HRESULT PutPixelDataDT(IDirect3DSurface9 *dst, const PIXEL_YC *src, EXEC_MT func_mt);
	HRESULT GetRenderTargetData();
	HRESULT GetPixelData(PIXEL_YC *dst, IDirect3DSurface9 *sys, EXEC_MT func_mt);
	HRESULT ShowMessageBox(const char *file, DWORD line, HRESULT hr, const TCHAR *msg);

	HRESULT UpdateSurface(IDirect3DSurface9 *src, IDirect3DTexture9 *dst);
	HRESULT SetRenderTarget(IDirect3DTexture9 *dst);
	HRESULT SetPixelFmt(PIXEL_FORMAT fmt);

	D3DFORMAT PicFmtToD3DFmt(PIXEL_FORMAT p) const;
	static void __cdecl AsyncProc(void *param);

#ifdef PROFILE_GPU
	HRESULT CreateQuery();
#endif
};

//---------------------------------------------------------------------
// macro
//---------------------------------------------------------------------
#ifndef SAFE_DELETE
#define SAFE_DELETE(p)       { if(p) { delete (p);     (p)=NULL; } }
#endif    
#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }
#endif    
#ifndef SAFE_RELEASE
#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }
#endif
